/**************************************************************************

	WWWC (upMail.dll)

	main.c

	(C) Copyright 1996-2000 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/


/**************************************************************************
	Include Files
**************************************************************************/

#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE

#include "wwwcdll.h"
#include "Option.h"
#include "CreateBody.h"
#include "smtp.h"
#include "resource.h"


/**************************************************************************
	Define
**************************************************************************/

#define BUF_SIZE			256			/* obt@TCY */
#define FMT_SIZE			32768		/* obt@TCY */


/**************************************************************************
	Global Variables
**************************************************************************/

static HINSTANCE ghinst;				/* AvP[ṼCX^Xnh */
char CuDir[BUF_SIZE];

char Name[BUF_SIZE];					/* { */
char MailAddress[BUF_SIZE];				/* [AhX */
char ServerName[BUF_SIZE];				/* SMTPT[o */
char ServerPort[BUF_SIZE];				/* |[gԍ */

int SendCheckType;
int SendAutoCheck;

char ToAddress[100][BUF_SIZE];			/*  */
int ToAddressCnt;
char Subject[BUF_SIZE];					/*  */
char SendSubject[BUF_SIZE];				/*  (Mp) */

char ListFormat[FMT_SIZE];
char Header[FMT_SIZE];
char Footer[FMT_SIZE];

int TargetFlag;
char TargetDir[100][BUF_SIZE];
int TargetDirCnt;


/**************************************************************************
	Local Function Prototypes
**************************************************************************/

static BOOL CALLBACK StatsProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);


/******************************************************************************

	DllMain

	C

******************************************************************************/

int WINAPI DllMain(HINSTANCE hInst, DWORD fdwReason, PVOID pvReserved)
{
	char ini_path[BUF_SIZE];
	char buf[BUF_SIZE];
	char *p, *r;
	int i;

	ghinst = hInst;
	GetModuleFileName(ghinst, CuDir, BUF_SIZE - 1);
	p = CuDir;
	while(*p != '\0'){
		if(IsDBCSLeadByte((BYTE)*p) == TRUE){
			p++;
		}else if(*p == '\\'){
			r = p;
		}
		p++;
	}
	*r = '\0';

	wsprintf(ini_path, "%s\\upMail.ini", CuDir);
	GetPrivateProfileString("SEND", "Name", "", Name, BUF_SIZE - 1, ini_path);
	GetPrivateProfileString("SEND", "MailAddress", "", MailAddress, BUF_SIZE - 1, ini_path);
	GetPrivateProfileString("SEND", "ServerName", "", ServerName, BUF_SIZE - 1, ini_path);
	GetPrivateProfileString("SEND", "ServerPort", "25", ServerPort, BUF_SIZE - 1, ini_path);

	GetPrivateProfileString("SEND", "SendCheckType", "2", buf, BUF_SIZE - 1, ini_path);
	SendCheckType = atoi(buf);
	GetPrivateProfileString("SEND", "SendAutoCheck", "1", buf, BUF_SIZE - 1, ini_path);
	SendAutoCheck = atoi(buf);

	GetPrivateProfileString("HEADER", "Subject", "[WWWC:%y/%m/%d %h:%n] XVACe", Subject, BUF_SIZE - 1, ini_path);
	GetPrivateProfileString("HEADER", "ToAddressCnt", "", buf, BUF_SIZE - 1, ini_path);
	ToAddressCnt = atoi(buf);
	for(i = 0; i < ToAddressCnt; i++){
		wsprintf(buf, "ToAddress-%d", i);
		GetPrivateProfileString("HEADER", buf, "", ToAddress[i], BUF_SIZE - 1, ini_path);
	}

	GetPrivateProfileString("MAKE", "ListFormat", "%t\\r\\n    %u\\r\\n    %d (%s)\\r\\n", ListFormat, FMT_SIZE - 1, ini_path);
	GetPrivateProfileString("MAKE", "Header", "WWWC XVACeꗗ (%y/%m/%d %h:%n)\\r\\n------------------------------------------\\r\\n\\r\\n", Header, FMT_SIZE - 1, ini_path);
	GetPrivateProfileString("MAKE", "Footer", "------------------------------------------\\r\\nWWWC upMail\\r\\n", Footer, FMT_SIZE - 1, ini_path);

	GetPrivateProfileString("TARGET", "TargetFlag", "", buf, BUF_SIZE - 1, ini_path);
	TargetFlag = atoi(buf);
	GetPrivateProfileString("TARGET", "TargetDirCnt", "", buf, BUF_SIZE - 1, ini_path);
	TargetDirCnt = atoi(buf);
	for(i = 0; i < TargetDirCnt; i++){
		wsprintf(buf, "TargetDir-%d", i);
		GetPrivateProfileString("TARGET", buf, "", TargetDir[i], BUF_SIZE - 1, ini_path);
	}

    return TRUE;
}


/******************************************************************************

	GetToolList

	c[ݒ

******************************************************************************/

__declspec(dllexport) int CALLBACK GetToolList(int cnt, struct TP_TOOLS *tpToolInfo)
{
	int ret = 0;

	switch(cnt)
	{
	case 0:
		lstrcpy(tpToolInfo->title,"UPACe[őM(&M)");
		tpToolInfo->Action = TOOL_EXEC_CHECKEND | TOOL_EXEC_CHECKENDUP;
		lstrcpy(tpToolInfo->func,"MailSend");
		break;

	default:
		ret = -1;
		break;
	}
	return ret;
}


/******************************************************************************

	MailSend

	[M

******************************************************************************/

__declspec(dllexport) int CALLBACK MailSend(HWND hWnd, struct TPITEM **ToolItemList,
													  int ToolItemListCnt, int type, int CheckType)
{
	char *buf;

	if(type == TOOL_EXEC_PORP){
		//IvVʕ\
		SetOptions(hWnd, ghinst);
		return 1;
	}

	//ݒ肪sĂ邩`FbN
	if(*ServerName == '\0' && *MailAddress == '\0' && ToAddressCnt == 0){
		return 0;
	}

	//ACẽ`FbN
	if(ToolItemListCnt <= 0 || ToolItemList == NULL){
		return 0;
	}

	//`FbN̂ݑM
	if(SendAutoCheck == 1 && (CheckType & CHECKTYPE_AUTO) == 0){
		return 0;
	}

	//`FbN̎
	if((SendCheckType & CheckType) == 0){
		return 0;
	}

	//{̐
	buf = CreateBody(hWnd, ToolItemList, ToolItemListCnt);
	if(buf == NULL){
		return 0;
	}

	//Subject̕ϊ
	FmtToParamString(Subject, SendSubject, BUF_SIZE - 10);

	//[M
	DialogBoxParam(ghinst, MAKEINTRESOURCE(IDD_DIALOG_STATS), hWnd, (DLGPROC)StatsProc, (LPARAM)buf);

	LocalFree(buf);
	return 1;
}


/******************************************************************************

	StatsProc

	ԃEBhEvV[W

******************************************************************************/

static BOOL CALLBACK StatsProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static SOCKET soc;
	static HWND stWnd;
	RECT DialogRect;
	char ErrStr[BUF_SIZE];

	switch(uMsg)
	{
	case WM_INITDIALOG:
		//QdNs
		if(stWnd != NULL){
			EndDialog(hDlg, FALSE);
			break;
		}
		stWnd = hDlg;

		/* EBhE𒆉ɕ\ */
		GetWindowRect(hDlg, &DialogRect);
		SetWindowPos(hDlg, HWND_TOPMOST,
			(GetSystemMetrics(SM_CXSCREEN) / 2) - ((DialogRect.right - DialogRect.left) / 2),
			(GetSystemMetrics(SM_CYSCREEN) / 2) - ((DialogRect.bottom - DialogRect.top) / 2),
			0, 0, SWP_SHOWWINDOW | SWP_NOSIZE);

		/* WinSock̏s */
		if(WSock_Init(ErrStr) == FALSE){
			MessageBox(hDlg, ErrStr, "Error", MB_ICONHAND);
			SendMessage(hDlg, WM_CLOSE, 0, 0);
		}
		/* T[oւ̐ڑJn */
		if((soc = ConnectServer(hDlg, (char *)lParam, ErrStr)) == -1){
			MessageBox(hDlg, ErrStr, "Error", MB_ICONHAND);
			SendMessage(hDlg, WM_CLOSE, 0, 0);
		}
		break;

	case WSOCK_SELECT:						/* \PbgCxg̃bZ[W̏ꍇ(WSAAsyncSelect֐ɂēo^) */
		/* G[̔ */
		if(soc != -1 && WSAGETSELECTERROR(lParam) != 0){
			SockeClose(hDlg, soc);
			MessageBox(hDlg, "SocketCxg̒ʒmŃG[܂B", "Error", MB_ICONHAND);
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;
		}
		/* ׂ\Pbg */
		if(soc != (int)wParam){
			break;
		}
		/* \PbgCxg̏s */
		switch(WSAGETSELECTEVENT(lParam))
		{
		case FD_CONNECT:					/* T[oւ̐ڑCxg */
			break;

		case FD_READ:						/* Mobt@Ƀf[^鎖Cxg */
			/* f[^MSMTP̏s */
			if(SendMailProc(hDlg, soc, ErrStr) == FALSE){
				SockeClose(hDlg, soc);
				MessageBox(hDlg, ErrStr, "MG[", MB_ICONHAND);
				SendMessage(hDlg, WM_CLOSE, 0, 0);
			}
			break;

		case FD_WRITE:						/* M\ł鎖Cxg */
			/* {̑Ms */
			if(SendProc(hDlg, soc, ErrStr) == FALSE){
				SockeClose(hDlg, soc);
				MessageBox(hDlg, ErrStr, "MG[", MB_ICONHAND);
				SendMessage(hDlg, WM_CLOSE, 0, 0);
			}
			break;

		case FD_CLOSE:						/* T[oւ̐ڑICxg */
			/* ڑI */
			SockeClose(hDlg, soc);
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;
		}
		break;

	case WSOCK_MESSAGE:
		/* ʐMԂ\ */
		SetWindowText(GetDlgItem(hDlg, IDC_STATIC_MSG), (char *)lParam);
		break;

	case WM_CLOSE:
		stWnd = NULL;
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDCANCEL:
			/* ڑIă_CAO */
			send(soc, "RSET\r\n", lstrlen("RSET\r\n"), 0);
			SockeClose(hDlg, soc);
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}
/* End of source */
